/*
GetEroImg.c 
\[X܂DLLjpgt@CoB
*/

#include "getresimg.h"


/*
DLLf[^o

hwnd    = EChEnh
DLLname = DLLt@C
type    = \[X^Cv
id      = \[XID
size    = f[^̃TCYԂ(|C^)֐sωB

f[^ԂBgIfree邱ƁB
sNULLԂB
*/
char *ReadRes(HWND hwnd, const char *DLLname, const char *type, DWORD id, DWORD *size)
{
    HMODULE hModule;
    HRSRC hrsrc;
    DWORD ressize;
    HANDLE hres;
    char *res;
    char *data;
    
    //DLLJ܂
    hModule = LoadLibrary(DLLname);
    if (hModule == NULL) {
        Mes(hwnd, "dllǂݍ߂Ȃ");
        return NULL;
    }
    //wid̃\[XT
    hrsrc = FindResource(hModule, MAKEINTRESOURCE(id), type);
    if (hrsrc == NULL) {
        Mes(hwnd, "T̃\[X炸");
        FreeLibrary(hModule);
        return NULL;
    }
    //TCY擾
    ressize = SizeofResource(hModule, hrsrc);
    if (ressize == 0) {
        Mes(hwnd, "\[X0oCg");
        FreeLibrary(hModule);
        return NULL;
    }
    
    hres = LoadResource(hModule, hrsrc);
    if (hres == NULL) {
        Mes(hwnd, "LoadResources");
        FreeLibrary(hModule);
        return NULL;
    }
    
    //f[^̃|C^擾
    res = (char *)LockResource(hres);
    if (res == NULL) {
        Mes(hwnd, "LockResources");
        FreeLibrary(hModule);
        return NULL;
    }
    //Rs[
     data = malloc(ressize);
    if (data == NULL) {
        Mes(hwnd, "Ȃ");
        FreeLibrary(hModule);
        return NULL;
    }
    memcpy(data,res,ressize);
    FreeLibrary(hModule);
    *size = ressize;
    return data;
}
